function B=anisotropic_averaging_3D(A,num_epochs,long_epoch,first)

% Filters the matrix taking into account the similarity between the time series of 
% the pixels.
% The measure of similarity between time series is actually the cross correlation 
% between the spectrums only at the selected frequencies (0 to 0.4 Hz).
% The parameters are:
% A: The 4D matrix containing the time series which are being analyzed.
% total_time: The total time of the acquisition, is needed to calculate the sample frequency.

dim = size(A)

lim=num_epochs*5;

FAux=abs(fft(A,[],4));
for i=1:dim(1)
   for j=1:dim(2)
      for k=1:dim(3)
         FA(i,j,k,:)=FAux(i,j,k,2:lim)/norm(squeeze(FAux(i,j,k,2:lim)));
      end      
   end
end
clear FAux;

B=A;

ini=2;


% We only take care of the central part of the matrix, and the first and last slice.

% First slice
% Regular pixels, namely those who are not in the border of the grid.

for i=ini:(dim(1)-1)
   for j=ini:(dim(2)-1)
      total_weight=0;
      target = squeeze(FA(i,j,1,:));
      w(:,1)=squeeze(A(i,j,1,:));
      for k=1:2
        % if k>1 anyadir los vecinos colineales ...
            
         destiny = squeeze(FA(i,j-1,k,:)); 	% Left neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,k+1)=total_weight.*squeeze(A(i,j-1,k,:));
         destiny = squeeze(FA(i-1,j,k,:)); 	% Up neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,k+3)=aux.*squeeze(A(i-1,j,k,:));
         destiny = squeeze(FA(i+1,j,k,:)); 	% Down neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,k+5)=aux.*squeeze(A(i+1,j,k,:));
         destiny = squeeze(FA(i-1,j-1,k,:)); % Left up neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,k+7)=aux.*squeeze(A(i-1,j-1,k,:));
         destiny = squeeze(FA(i+1,j-1,k,:)); % Left down neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,k+9)=aux.*squeeze(A(i+1,j-1,k,:));
         destiny = squeeze(FA(i,j+1,k,:)); 	% Right neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,k+11)=aux.*squeeze(A(i,j+1,k,:));
         destiny = squeeze(FA(i-1,j+1,k,:)); % Right up neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,k+13)=aux.*squeeze(A(i-1,j+1,k,:));
         destiny = squeeze(FA(i+1,j+1,k,:)); % Right down neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,k+15)=aux.*squeeze(A(i+1,j+1,k,:));
      end
      destiny = squeeze(FA(i,j,2,:)); % Right down neighbour.
      aux=similarity(target,destiny,long_epoch,num_epochs,first);
      total_weight=total_weight+aux; 
      w(:,18)=aux.*squeeze(A(i,j,2,:));
      B(i,j,1,:)=sum(w,2)/(1+total_weight);
   end   
end

clear w;
% Last slice
% Regular pixels, namely those who are not in the border of the grid.

for i=ini:(dim(1)-1)
   for j=ini:(dim(2)-1)
      total_weight=0;
      target = squeeze(FA(i,j,dim(3),:));
      w(:,1)=squeeze(A(i,j,dim(3),:));      
      t=0;
      for k=dim(3)-1:dim(3)         
         t=t+1;
         destiny = squeeze(FA(i,j-1,k,:)); 	% Left neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,t+1)=total_weight.*squeeze(A(i,j-1,k,:));
         destiny = squeeze(FA(i-1,j,k,:)); 	% Up neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,t+3)=aux.*squeeze(A(i-1,j,k,:));
         destiny = squeeze(FA(i+1,j,k,:)); 	% Down neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,t+5)=aux.*squeeze(A(i+1,j,k,:));
         destiny = squeeze(FA(i-1,j-1,k,:)); % Left up neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,t+7)=aux.*squeeze(A(i-1,j-1,k,:));
         destiny = squeeze(FA(i+1,j-1,k,:)); % Left down neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,t+9)=aux.*squeeze(A(i+1,j-1,k,:));
         destiny = squeeze(FA(i,j+1,k,:)); 	% Right neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,t+11)=aux.*squeeze(A(i,j+1,k,:));
         destiny = squeeze(FA(i-1,j+1,k,:)); % Right up neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,t+13)=aux.*squeeze(A(i-1,j+1,k,:));
         destiny = squeeze(FA(i+1,j+1,k,:)); % Right down neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,t+15)=aux.*squeeze(A(i+1,j+1,k,:));
      end
      destiny = squeeze(FA(i,j,dim(3)-1,:)); % Right down neighbour.
      aux=similarity(target,destiny,long_epoch,num_epochs,first);
      total_weight=total_weight+aux;
      w(:,18)=aux.*squeeze(A(i,j,dim(3)-1,:));
      B(i,j,dim(3),:)=sum(w,2)/(1+total_weight);
   end   
end

clear w;
% Last slice
% Regular pixels, namely those who are not in the border of the grid.

for i=ini:(dim(1)-1)
   for j=ini:(dim(2)-1)
      for l=2:(dim(3)-1)
         total_weight=0;
         t=0;
         target = squeeze(FA(i,j,l,:));
         w(:,1)=squeeze(A(i,j,l,:));
         for k=l-1:l+1  
            t=t+1;            
            destiny = squeeze(FA(i,j-1,k,:)); 	% Left neighbour.
            aux=similarity(target,destiny,long_epoch,num_epochs,first);
            total_weight=total_weight+aux; 
            w(:,t+1)=total_weight.*squeeze(A(i,j-1,k,:));
            destiny = squeeze(FA(i-1,j,k,:)); 	% Up neighbour.
            aux=similarity(target,destiny,long_epoch,num_epochs,first);
            total_weight=total_weight+aux; 
            w(:,t+4)=aux.*squeeze(A(i-1,j,k,:));
            destiny = squeeze(FA(i+1,j,k,:)); 	% Down neighbour.
            aux=similarity(target,destiny,long_epoch,num_epochs,first);
            total_weight=total_weight+aux; 
            w(:,t+7)=aux.*squeeze(A(i+1,j,k,:));
            destiny = squeeze(FA(i-1,j-1,k,:)); % Left up neighbour.
            aux=similarity(target,destiny,long_epoch,num_epochs,first);
            total_weight=total_weight+aux; 
            w(:,t+10)=aux.*squeeze(A(i-1,j-1,k,:));
            destiny = squeeze(FA(i+1,j-1,k,:)); % Left down neighbour.
            aux=similarity(target,destiny,long_epoch,num_epochs,first);
            total_weight=total_weight+aux; 
            w(:,t+13)=aux.*squeeze(A(i+1,j-1,k,:));
            destiny = squeeze(FA(i,j+1,k,:)); 	% Right neighbour.
            aux=similarity(target,destiny,long_epoch,num_epochs,first);
            total_weight=total_weight+aux; 
            w(:,t+16)=aux.*squeeze(A(i,j+1,k,:));
            destiny = squeeze(FA(i-1,j+1,k,:)); % Right up neighbour.
            aux=similarity(target,destiny,long_epoch,num_epochs,first);
            total_weight=total_weight+aux; 
            w(:,t+19)=aux.*squeeze(A(i-1,j+1,k,:));
            destiny = squeeze(FA(i+1,j+1,k,:)); % Right down neighbour.
            aux=similarity(target,destiny,long_epoch,num_epochs,first);
            total_weight=total_weight+aux; 
            w(:,t+22)=aux.*squeeze(A(i+1,j+1,k,:));            
         end
         destiny = squeeze(FA(i,j,l-1,:)); % Right down neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,26)=aux.*squeeze(A(i,j,l-1,:));
         destiny = squeeze(FA(i,j,l+1,:)); % Right down neighbour.
         aux=similarity(target,destiny,long_epoch,num_epochs,first);
         total_weight=total_weight+aux; 
         w(:,27)=aux.*squeeze(A(i,j,l+1,:));
         B(i,j,l,:)=sum(w,2)/(1+total_weight);
      end
   end   
end

